uses Inferno, VGAColors, X, XLib, X11, XUtil;

const
  AnodSize	= 48;
  AnodStep	= 50;
  AnodBorder	= 1;

  PrevBorder	= 4;

  AnodXNum	= 5-1;
  AnodYNum	= 7-1;

  CursX		: LongInt = 0;
  CursY		: LongInt = 0;
  CurC		: LongInt = 0;
  BlB		: LongInt = 0;
  BlK		: LongInt = 0;

  BitMask	: Array[0..6] of Byte = ($01, $02, $04, $08, $10, $20, $40);

type
  tSym		= Record
    bits	: Array[0..4] of byte;	//   
    en		: Boolean;		//    asm-e
    res		: Array[0..7] of byte;  //   
  end;

  tSymBase	= Array[0..255] of tSym;

var
  f		: File of tSymBase;
  SymBase	: tSymBase;
  WndPrev,
  WndMatr	: TWindow;
  Event		: TXEvent;
  Col		: TColors;
  GC		: TGC;

procedure DrawMatrix;
var x, y: LongInt; b: Byte;

begin With SymBase[CurC] do
  For x := 0 to AnodXNum do begin
    b := bits[x];
    For y := 0 to AnodYNum do begin

      XSetForeGround(prDisplay, GC, Col[15]);
      // SetFillStyle(SolidFill, GetColor);
      XFillRectangle(prDisplay, WndMatr, GC, x*AnodStep, y*AnodStep, AnodSize, AnodSize);

      if odd(b) then XSetForeGround(prDisplay, GC, Col[10]) else XSetForeGround(prDisplay, GC, Col[0]);
      XFillRectangle(prDisplay, WndMatr, GC, x*AnodStep+AnodBorder, y*AnodStep+AnodBorder, AnodSize-AnodBorder*2, AnodSize-AnodBorder*2);

      if (x = CursX) and (y = CursY) then begin
        XSetForeGround(prDisplay, GC, Col[12]);
        XDrawLine(prDisplay, WndMatr, GC, x*AnodStep+AnodBorder, y*AnodStep+AnodBorder, x*AnodStep+AnodBorder + AnodSize-AnodBorder*2, y*AnodStep+AnodBorder + AnodSize-AnodBorder*2);
        XDrawLine(prDisplay, WndMatr, GC, x*AnodStep+AnodBorder + AnodSize-AnodBorder*2, y*AnodStep+AnodBorder, x*AnodStep+AnodBorder, y*AnodStep+AnodBorder + AnodSize-AnodBorder*2);	
      end;

      b := b shr 1;
    end;
  end;
end;

procedure DrawPreview;
var x, y, cx, cy: LongInt; b, C: Byte;

begin
  For C := Low(SymBase) to High(SymBase) do With SymBase[C] do
    For x := 0 to AnodXNum do begin
      b := bits[x];
      For y := 0 to AnodYNum do begin

	cx := (c mod 16) * (PrevBorder + AnodXNum);
	cy := (c div 16) * (PrevBorder + AnodYNum);
{
	if C = CurC then begin
	  XSetForeGround(prDisplay, GC, Col[12]);
	  XDrawRectangle(prDisplay, WndPrev, GC, cx, cy, AnodXNum, AnodYNum);
	end;
}
        if odd(b) then if (C >= BlB) and (C <= BlK) then XSetForeGround(prDisplay, GC, Col[12]) else XSetForeGround(prDisplay, GC, Col[10]) else if C = CurC then XSetForeGround(prDisplay, GC, Col[7]) else XSetForeGround(prDisplay, GC, Col[0]);
        XDrawPoint(prDisplay, WndPrev, GC, x + cx, y + cy);

        b := b shr 1;
      end;
      if en then else begin
        XSetForeGround(prDisplay, GC, Col[14]);
	XDrawLine(prDisplay, WndPrev, GC, cx, cy, cx+AnodXNum, cy+AnodYNum);
      end;
    end;
end;

procedure ClearSym;
var x: LongInt;
begin With SymBase[CurC] do
  For x := 0 to AnodXNum do bits[x] := 0;
end;

procedure XorSym;
var x: LongInt;
begin With SymBase[CurC] do
  For x := 0 to AnodXNum do bits[x] := not bits[x];
end;

procedure ScrollUp;
var x: LongInt;
begin With SymBase[CurC] do
  For x := 0 to AnodXNum do bits[x] := bits[x] shr 1;
end;

procedure ScrollDown;
var x: LongInt;
begin With SymBase[CurC] do
  For x := 0 to AnodXNum do bits[x] := (bits[x] shl 1) and $FF;
end;

procedure ScrollLeft;
var t: Byte;
begin With SymBase[CurC] do begin
  t	  := bits[0];
  bits[0] := bits[1];
  bits[1] := bits[2];
  bits[2] := bits[3];
  bits[3] := bits[4];
  bits[4] := t;
end end;

procedure ScrollRight;
var t: Byte;
begin With SymBase[CurC] do begin
  t	  := bits[4];
  bits[4] := bits[3];
  bits[3] := bits[2];
  bits[2] := bits[1];
  bits[1] := bits[0];
  bits[0] := t;
end end;

procedure MoveBlock;
var t: tSymBase; C, L: LongInt;
begin
  t := SymBase; L := BlK - BlB;

  For C := BlB to High(SymBase) - L - 1 do SymBase[C] := SymBase[C + L + 1];

  For C := High(SymBase) - L - 1 downto CurC do SymBase[C + L + 1] := SymBase[C];

  For C := BlB to BlK do SymBase[CurC + C - BlB] := t[C];

  BlB := CurC;
  BlK := BlB + L;
end;

procedure BuildAsm;
const t: Array[0..AnodYNum, 0..AnodXNum] of string[2] = (
  ('d5', 'a4', 'b5', 'b1', 'd6'), // 0
  ('c4', 'b7', 'a2', 'c7', 'b2'), // 1
  ('b6', 'a3', 'c5', 'c2', 'd7'), // 2
  ('d1', 'a7', 'b3', 'c6', 'a1'), // 3
  ('e5', 'c1', 'e3', 'd4', 'e4'), // 4
  ('d3', 'e7', 'd2', 'e2', 'c3'), // 5
  ('e1', 'a6', 'a5', 'b4', 'e6')  // 6
); //  -   4,  -    P1
const m: Array['0'..'7'] of Byte = ($01, $02, $04, $08, $10, $20, $40, $80);
var f: Text; C, x, y, x1, n: LongInt; state: Array[0..AnodXNum] of Byte;
begin
  n := 0;
  assign(f, 'indic1.inc'); rewrite(f);
  For C := Low(SymBase) to High(SymBase) do With SymBase[C] do if en then begin
    //  bits    state    

    For x := 0 to AnodXNum do state[x] := $01; // P1.0       

    For x := 0 to AnodXNum do For y := 0 to AnodYNum do if (bits[x] and BitMask[y]) <> 0 then begin
      x1 := ord(t[y, x][1]) - ord('a');
      state[x1] := state[x1] or m[t[y, x][2]];
    end;        

    //   state  
    Write(f, '.byte ');
    For x := 0 to AnodXNum do begin
      Write(f, '0x', HexStr(state[x], 2): 2);
      if x < AnodXNum then Write(f, ', ');
    end;
    WriteLn(f, ', 0, 0, 0 ;', C: 4, ' ', chr(C), n: 4);
    inc(n);
  end;
  close(f);
end;

begin
  assign(f, 'base.bin'); reset(f); read(f, SymBase); close(f);

  NewRootWindow(405, 235, AnodStep * AnodXNum + AnodSize, AnodStep * AnodYNum + AnodSize, 10, 10, 'CharEdit', 'CharEdit', WndMatr);
  NewRootWindow(200, 200, (PrevBorder + AnodXNum) * 16, (PrevBorder + AnodYNum) * 16, 10, 10, 'CharEdit', 'CharEdit', WndPrev);
  SetVGAPalette(WndMatr, Col);
  GC := XCreateGC(prDisplay, WndMatr, 0, Nil);  

  repeat
    KeyInResult := 0;
    DrawMatrix;
    DrawPreview;
    if ((CurC >= 32) and (CurC <= 126)) or (CurC >= $a0) then Write(Chr(CurC)) else Write('.');
    Writeln(' ', CurC);
    FlTmWithPause(Event, True);
    Case Event.EventType of
      Expose: Begin DrawMatrix; DrawPreview; End;
      
    end;
    
    if TestMKey(skLShift) then Case KeyInResult of

      XK_Left		: ScrollLeft;
      XK_Right		: ScrollRight;
      XK_Up		: ScrollUp;
      XK_Down		: ScrollDown;

      XK_Page_Up	: CurC := (CurC - 16) and $FF;
      XK_Page_Down	: CurC := (CurC + 16) and $FF;

    end else Case KeyInResult of

      // 
      XK_F2: Begin
        rewrite(f); write(f, SymBase); close(f);
      end;

      //   
      XK_F6: if BlB <= BlK then if BlK - BlB <= High(SymBase) - CurC then MoveBlock;

      //      
      XK_Home: BlB := CurC;

      //      
      XK_End: BlK := CurC;

      //    asm'e
      XK_F10: BuildAsm;

      // /   asm'a
      XK_BackSpace: With SymBase[CurC] do en := not en;

      //  
      Ord(' '): Begin
        With SymBase[CurC] do bits[CursX] := bits[CursX] xor BitMask[CursY];
      end;

      //   
      Ord('e'): ClearSym;

      //   
      Ord('x'): XorSym;

{
      Ord('n'): Begin
        Write('New pos : ');
	ReadLn(SymBase[CurC].numb);
      end;
}
      XK_Left		: if CursX = 0 then CursX := AnodXNum else dec(CursX);
      XK_Right		: if CursX = AnodXNum then CursX := 0 else inc(CursX);
      XK_Up		: if CursY = 0 then CursY := AnodYNum else dec(CursY);
      XK_Down		: if CursY = AnodYNum then CursY := 0 else inc(CursY);

      XK_Page_Up	: if CurC < High(SymBase) then inc(CurC);
      XK_Page_Down	: if CurC > Low(SymBase) then dec(CurC);

    end;
  until KeyInResult = XK_Escape;
  
end.
